zookeeper-dev mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From eribeiro <...@git.apache.org>
Subject [GitHub] zookeeper pull request #257: ZOOKEEPER-2784: Add same `sid` config problem c...
Date Fri, 19 May 2017 04:54:20 GMT
Github user eribeiro commented on a diff in the pull request:

    https://github.com/apache/zookeeper/pull/257#discussion_r117403350
  
    --- Diff: src/java/main/org/apache/zookeeper/server/quorum/QuorumCnxManager.java ---
    @@ -660,6 +665,9 @@ public void run() {
                                 "Ignoring exception", ie);
                         }
                         closeSocket(client);
    +                } catch (ConfigException ce) {
    +                    LOG.error(ce.getMessage());
    +                    throw new RuntimeException(ce);
    --- End diff --
    
    Don't we have to call `closeSocket(client)` here before throwing the `RuntimeException`?
Relying on OS/JVM to close a socket can be too much optimistic and leak resources. If I am
right (please double check) then line 667 can be moved to a finally block just below this
catch clause.
    
    Also, as the program flow is interrupted if a `ConfigException` is thrown lines 679-687
wouldn't be called and then `ServerSocket` also is not properly closed, right?
    
    PS: I am not sure, would have to look carefully later and don't have time now, so excuse
me if I am misunderstood it.



---
If your project is set up for it, you can reply to this email and have your
reply appear on GitHub as well. If your project does not have this feature
enabled and wishes so, or if the feature is enabled but not working, please
contact infrastructure at infrastructure@apache.org or file a JIRA ticket
with INFRA.
---

Mime
View raw message